
#include "hdstr.h"
#include "bios.h"

 // typedef struct
 // {
 // 	struct s_samadr  faradr;
 // 	unsigned short af_,bc_,de_,hl_;
 // 	unsigned short af,bc,de,hl,ix,iy;
 // } regs;

void bios (regs *regs)
{
// on entry de will point to regs	

#asm
; save all regs	
	push ix
	push iy
	push hl
	push de
	push bc
	push af
	exx
	ex af,af'
	push hl
	push de
	push bc
	push af

; push all new values onto the stack	
	ex de,hl
	ld a,(hl)
	push af		; page number
	ld b,11
L1:
	inc hl
	ld e,(hl)
	inc hl
	ld d,(hl)
	push de
	djnz L1

; load registers from stack
	pop iy
	pop ix
	pop hl
	pop de
	pop bc
	pop af
	exx
	ex af,af'
	pop hl
	pop de
	pop bc
	pop af
	exx
	ex af,af'

; call the routine paging etc is done in sam heap in page B	
;	call farcall	
	defb 0xCD
farcall:defw 0		; will be set up by init

	
	

	
; restore all regs
	pop af
	pop bc
	pop de
	pop hl
	ex af,af'
	exx
	pop af
	pop bc
	pop de
	pop hl
	pop iy
	pop ix
#endasm
}

	
